#include "HW10Utility.h"
#include "Solution.cpp"
#include "HW10Helper.h"
#include "Graph.h"
#include <fstream>

using namespace std;
using literals = vector<pair<int, int>>;

class Driver;

int main(int argc, char** argv) {
    if(argc != 2) {
        printf("Please provide the input filename as the argument.\n");
        return 0;
    }
    HW10Utility Utility;
    Graph input = Utility.readFile(argv[1]);

    Solution s = Solution(input.k, input.graph);
    Helper h = Helper();

    vector<pair<literals, literals>> studentSolution = s.outputClauses();
    cout << "Your solution " << endl;
    cout << "==========================================" << endl;
    h.printResult(studentSolution);
    cout << "==========================================" << endl;
    h.writeCnf(input, h.convertFormat(&studentSolution, input.k));
    return 0;
}
